// OpenMenuDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "OpenMenu.h"
#include "OpenMenuDlg.h"
#include "EditDlg.h"
#include <stdio.h>
#include <process.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Hack, damit die Applikations-Icons mit korrektem Alphakanal dargestellt werden:
// Quelle: https://stackoverflow.com/questions/24269418/why-am-i-getting-black-background-when-displaying-a-list-view-icon
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")

/////////////////////////////////////////////////////////////////////////////
// COpenMenuDlg Dialogfeld

COpenMenuDlg::COpenMenuDlg(CString strPath, CWnd* pParent /*=NULL*/)
	: CDialog(COpenMenuDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COpenMenuDlg)
		// HINWEIS: Der Klassenassistent fgt hier Member-Initialisierung ein
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_strPath = strPath;
}

void COpenMenuDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COpenMenuDlg)
	DDX_Control(pDX, IDC_LIST_APPS, m_lstApps);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(COpenMenuDlg, CDialog)
	//{{AFX_MSG_MAP(COpenMenuDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_NOTIFY(NM_CLICK, IDC_LIST_APPS, OnClickListApps)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_MENU_OPEN, OnMenuOpen)
	ON_COMMAND(ID_MENU_DEFAULT, OnMenuDefault)
	ON_COMMAND(ID_MENU_ADD, OnMenuAdd)
	ON_COMMAND(ID_MENU_EDIT, OnMenuEdit)
	ON_COMMAND(ID_MENU_DELETE, OnMenuDelete)
	ON_WM_SIZE()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

  /////////////////////////
 // Nachrichten-Handler // 
/////////////////////////

BOOL COpenMenuDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// ZU ERLEDIGEN: Hier zustzliche Initialisierung einfgen
	m_strExtension = GetFileExtension(m_strPath);

	if(m_strExtension.IsEmpty())
	{
		AfxMessageBox(CString(MAKEINTRESOURCE(IDS_MSG_ERROR_MISSING_EXTENSION)));
		EndDialog(IDCANCEL);
	}

	LoadSettings();
	LoadAppList();

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void COpenMenuDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR COpenMenuDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void COpenMenuDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	
	if(::IsWindow(m_lstApps))
	{
		m_lstApps.SetWindowPos(NULL, 0, 0, cx, cy, SWP_NOZORDER | SWP_NOMOVE);
		SortItems();
	}
}

void COpenMenuDlg::OnCancel()
{
	SaveSettings();

	CDialog::OnCancel();
}

void COpenMenuDlg::OnClose() 
{
	SaveSettings();
	
	CDialog::OnClose();
}

void COpenMenuDlg::OnOK()
{
	SaveSettings();

	// Item ermitteln und Programm aufrufen mit Datei als Parameter

	CString strCompanyName(AfxGetApp()->m_pszRegistryKey);
	CString strAppName(AfxGetApp()->m_pszAppName);

	if(m_lstApps.GetSelectedCount() != 1)
		return;

	int nItem = -1;
	POSITION pos = m_lstApps.GetFirstSelectedItemPosition();
	if(pos)
	{
		nItem = m_lstApps.GetNextSelectedItem(pos);
	}

	if(nItem == -1)
		return;

	CItemData *pItemData = (CItemData*)m_lstApps.GetItemData(nItem);
	CString strApplication = pItemData->m_strApplication;

	CString strKeyApplication;
	strKeyApplication.Format
	(
		"Software\\%s\\%s\\Applications\\%s", 
		(LPCTSTR)strCompanyName, 
		(LPCTSTR)strAppName, 
		(LPCTSTR)strApplication
	);

	CString strKeyExtension;
	strKeyExtension.Format
	(
		"Software\\%s\\%s\\Extensions\\%s\\%s",
		(LPCTSTR)strCompanyName,
		(LPCTSTR)strAppName,
		(LPCTSTR)m_strExtension,
		(LPCTSTR)strApplication
	);

	CRegKey keyApplication;
	if(ERROR_SUCCESS == keyApplication.Open(HKEY_CURRENT_USER, strKeyApplication, KEY_READ))
	{
		char szPath[MAX_PATH];
		char szParam[MAX_PATH] = "";

		DWORD dwCountPath = sizeof(szPath);
		DWORD dwCountParam = sizeof(szParam);

		if(ERROR_SUCCESS == keyApplication.QueryStringValue("Path", szPath, &dwCountPath))
		{
			CRegKey keyExtension;
			if (ERROR_SUCCESS == keyExtension.Open(HKEY_CURRENT_USER, strKeyExtension, KEY_READ))
			{
				keyExtension.QueryStringValue("Parameters", szParam, &dwCountParam);
				keyExtension.Close();
			}

			CString strParameters(szParam);
			if (strParameters.IsEmpty())
			{
				strParameters = Quote(m_strPath);
			}
			else
			{
				strParameters.Replace("%1", m_strPath);
			}

			ShellExecute(NULL, "open", Quote(szPath), strParameters, "", SW_SHOWNORMAL);
			EndDialog(IDOK);
		}
		else
		{
			AfxMessageBox(CString(MAKEINTRESOURCE(IDS_MSG_ERROR_READING_REGKEY)) + ":\n" + strKeyApplication);
		}
		keyApplication.Close();
	}
	else
	{
		AfxMessageBox(CString(MAKEINTRESOURCE(IDS_MSG_ERROR_OPENING_REGKEY)) + ":\n" + strKeyApplication);
	}
}

void COpenMenuDlg::OnClickListApps(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnOK();
	
	*pResult = 0;
}

void COpenMenuDlg::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	CRect rcList;
	m_lstApps.GetWindowRect(&rcList);

	if(!rcList.PtInRect(point))
		return;

	CMenu mnuPopup;
	if(!mnuPopup.LoadMenu(IDR_POPUP_MENU))
		return;

	int nCountSelectedItems = m_lstApps.GetSelectedCount();
	int nItem = -1;

	POSITION pos = m_lstApps.GetFirstSelectedItemPosition();
	if(pos)
	{
		nItem = m_lstApps.GetNextSelectedItem(pos);
	}

	CMenu *pContextMenu = mnuPopup.GetSubMenu(0);
	if(pContextMenu == NULL)
		return;

	// Diese Menpunkte sind nur aktiv, wenn genau 1 Anwendung in der Liste ausgewhlt ist:
	pContextMenu->EnableMenuItem(ID_MENU_OPEN, MF_BYCOMMAND | (nCountSelectedItems == 1 ? MF_ENABLED : MF_DISABLED | MF_GRAYED));
	pContextMenu->EnableMenuItem(ID_MENU_DEFAULT, MF_BYCOMMAND | (nCountSelectedItems == 1 ? MF_ENABLED : MF_DISABLED | MF_GRAYED));
	pContextMenu->EnableMenuItem(ID_MENU_EDIT, MF_BYCOMMAND | (nCountSelectedItems == 1 ? MF_ENABLED : MF_DISABLED | MF_GRAYED));
	pContextMenu->EnableMenuItem(ID_MENU_DELETE, MF_BYCOMMAND | (nCountSelectedItems == 1 ? MF_ENABLED : MF_DISABLED | MF_GRAYED));

	// "ffnen" ist die Standard-Aktion
	pContextMenu->SetDefaultItem(ID_MENU_OPEN);

	// Haken des "Standard"-Items setzen
	bool bIsDefault = false;
	if(m_lstApps.GetSelectedCount() == 1)
	{
		int nItem = -1;
		POSITION pos = m_lstApps.GetFirstSelectedItemPosition();
		if(pos)
		{
			nItem = m_lstApps.GetNextSelectedItem(pos);
		}
		CItemData *pItemData = (CItemData*)m_lstApps.GetItemData(nItem);
		bIsDefault = pItemData->m_bIsDefault;
	}
	pContextMenu->CheckMenuItem(ID_MENU_DEFAULT, MF_BYCOMMAND | (bIsDefault ? MF_CHECKED : MF_UNCHECKED));

	// Kontextmen anzeigen
	pContextMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this);
}

void COpenMenuDlg::OnMenuOpen()
{
	OnOK();
}

void COpenMenuDlg::OnMenuDefault()
{
	int nItemSelected = -1;
	POSITION pos = m_lstApps.GetFirstSelectedItemPosition();
	if(pos)
	{
		nItemSelected = m_lstApps.GetNextSelectedItem(pos);
	}

	if(nItemSelected == -1)
		return;

	for(int nItem = 0; nItem < m_lstApps.GetItemCount(); nItem++)
	{
		CItemData *pItemData = (CItemData*)m_lstApps.GetItemData(nItem);
		pItemData->m_bIsDefault = (nItem == nItemSelected && !pItemData->m_bIsDefault);

		// In Registry speichern

		CString strCompanyName(AfxGetApp()->m_pszRegistryKey);
		CString strAppName(AfxGetApp()->m_pszAppName);

		CString strKeyExtension;
		strKeyExtension.Format
		(
			"Software\\%s\\%s\\Extensions\\%s\\%s", 
			(LPCTSTR)strCompanyName, 
			(LPCTSTR)strAppName, 
			(LPCTSTR)m_strExtension, 
			(LPCTSTR)pItemData->m_strApplication
		);

		CRegKey keyExtension;
		if(ERROR_SUCCESS == keyExtension.Open(HKEY_CURRENT_USER, strKeyExtension, KEY_WRITE))
		{
			keyExtension.SetDWORDValue("Default", (DWORD)pItemData->m_bIsDefault);
			keyExtension.Close();
		}
	}
}

void COpenMenuDlg::OnMenuAdd()
{
	CString strPath, strName, strTitle;

	if (BrowseAppFile(strPath, strName, strTitle))
	{
		if (AddApplication(strPath, strName, strTitle))
		{
			LoadAppList();
		}
	}
}

void COpenMenuDlg::OnMenuEdit()
{
	CString strCompanyName(AfxGetApp()->m_pszRegistryKey);
	CString strAppName(AfxGetApp()->m_pszAppName);

	if(m_lstApps.GetSelectedCount() != 1)
		return;

	int nItem = -1;
	POSITION pos = m_lstApps.GetFirstSelectedItemPosition();
	if(pos)
	{
		nItem = m_lstApps.GetNextSelectedItem(pos);
	}

	if(nItem == -1)
		return;

	CItemData *pItemData = (CItemData*)m_lstApps.GetItemData(nItem);
	CString strApplication = pItemData->m_strApplication;

	CString strKeyApplication;
	strKeyApplication.Format
	(
		"Software\\%s\\%s\\Applications\\%s", 
		(LPCTSTR)strCompanyName, 
		(LPCTSTR)strAppName, 
		(LPCTSTR)strApplication
	);

	CString strKeyExtension;
	strKeyExtension.Format
	(
		"Software\\%s\\%s\\Extensions\\%s\\%s", 
		(LPCTSTR)strCompanyName, 
		(LPCTSTR)strAppName, 
		(LPCTSTR)m_strExtension, 
		(LPCTSTR)strApplication
	);

	CRegKey keyApplication;
	if(ERROR_SUCCESS == keyApplication.Open(HKEY_CURRENT_USER, strKeyApplication))
	{
		CRegKey keyExtension;
		if (ERROR_SUCCESS == keyExtension.Open(HKEY_CURRENT_USER, strKeyExtension))
		{
			char szName[MAX_PATH];
			char szPath[MAX_PATH];
			char szParam[MAX_PATH] = "";

			DWORD dwCountName = sizeof(szName);
			DWORD dwCountPath = sizeof(szPath);
			DWORD dwCountParam = sizeof(szParam);

			if(ERROR_SUCCESS == keyApplication.QueryStringValue("DisplayName", szName, &dwCountName)
			&& ERROR_SUCCESS == keyApplication.QueryStringValue("Path", szPath, &dwCountPath))
			{
				CEditDlg dlg(this);
				dlg.m_strName = szName;
				dlg.m_strPath = szPath;

				if (ERROR_SUCCESS == keyExtension.QueryStringValue("Parameters", szParam, &dwCountParam))
					dlg.m_strParam = szParam;

				if (IDOK == dlg.DoModal())
				{
					bool bLoadAppList = false;

					if (dlg.m_strName != szName)
					{
						if (ERROR_SUCCESS == keyApplication.SetStringValue("DisplayName", dlg.m_strName))
						{
							bLoadAppList = true;
						}
						else
						{
							AfxMessageBox(CString(MAKEINTRESOURCE(IDS_MSG_ERROR_WRITING_REGKEY)) + strKeyApplication);
						}
					}

					if (dlg.m_strPath != szPath)
					{
						if (ERROR_SUCCESS == keyApplication.SetStringValue("Path", dlg.m_strPath))
						{
							bLoadAppList = true;
						}
						else
						{
							AfxMessageBox(CString(MAKEINTRESOURCE(IDS_MSG_ERROR_WRITING_REGKEY)) + ":\n" + strKeyApplication);
						}
					}

					if (dlg.m_strParam != szParam)
					{
						if (ERROR_SUCCESS == keyExtension.SetStringValue("Parameters", dlg.m_strParam))
						{
							bLoadAppList = true;
						}
						else
						{
							AfxMessageBox(CString(MAKEINTRESOURCE(IDS_MSG_ERROR_WRITING_REGKEY)) + ":\n" + strKeyExtension);
						}
					}

					if (bLoadAppList)
						LoadAppList();
				}
			}
			else
			{
				AfxMessageBox(CString(MAKEINTRESOURCE(IDS_MSG_ERROR_READING_REGKEY)) + ":\n" + strKeyApplication);
			}
			keyExtension.Close();
		}
		else
		{
			AfxMessageBox(CString(MAKEINTRESOURCE(IDS_MSG_ERROR_OPENING_REGKEY)) + ":\n" + strKeyExtension);
		}
		keyApplication.Close();
	}
	else
	{
		AfxMessageBox(CString(MAKEINTRESOURCE(IDS_MSG_ERROR_OPENING_REGKEY)) + ":\n" + strKeyApplication);
	}
}

void COpenMenuDlg::OnMenuDelete()
{
	if(DeleteAssignment())
	{
		LoadAppList();
	}
}

  //////////////
 // Methoden //
//////////////

bool COpenMenuDlg::BrowseAppFile(CString& strPath, CString& strName, CString& strTitle)
{
	CFileDialog dlgFileBrowser
	(
		TRUE, NULL, NULL, OFN_ENABLESIZING | OFN_EXPLORER | OFN_FILEMUSTEXIST,
		"Ausfhrbare Dateien (*.exe; *.bat; *.cmd)|*.exe; *.bat; *.cmd|"
		"Anwendungen (*.exe)|*.exe|"
		"Stapelverarbeitungsdateien (*.bat)|*.bat|"
		"Befehlsskripte (*.cmd)|*.cmd|"
		"Alle Dateien (*.*)|*.*|"
		"|"
	);

	if (IDOK != dlgFileBrowser.DoModal())
		return false;

	strPath = dlgFileBrowser.GetPathName();
	strName = dlgFileBrowser.GetFileName();
	strTitle = dlgFileBrowser.GetFileTitle();

	return true;
}

void COpenMenuDlg::LoadAppList()
{
	m_lstApps.DeleteAllItems();
	// Eigentlich mten hier erst noch die CItemData-Objekte gelscht werden,
	// aber das erledigt Windows sptestens beim Beenden des Programms... ;)

	CString strCompanyName(AfxGetApp()->m_pszRegistryKey);
	CString strAppName(AfxGetApp()->m_pszAppName);

	CString strKeyExtension;
	strKeyExtension.Format
	(
		"Software\\%s\\%s\\Extensions\\%s", 
		(LPCTSTR)strCompanyName, 
		(LPCTSTR)strAppName, 
		(LPCTSTR)m_strExtension
	);

	CRegKey keyExtension;
	if(ERROR_SUCCESS != keyExtension.Open(HKEY_CURRENT_USER, strKeyExtension, KEY_READ))
	{
		return;
	}

	DWORD dwIndex = 0;
	char szApplication[MAX_PATH];
	DWORD dwCount = sizeof(szApplication);

	// Schleife ber alle Anwendungen, die dem Dateityp zugeordnet sind
	while(ERROR_SUCCESS == RegEnumKeyEx(keyExtension.m_hKey, dwIndex, szApplication, &dwCount, NULL, NULL, NULL, NULL))
	{
		// Ermitteln, ob die zugeordnete Anwendung die Standard-Anwendung ist
		bool bIsDefault = false;

		CString strKeyExtension;
		strKeyExtension.Format
		(
			"Software\\%s\\%s\\Extensions\\%s\\%s", 
			(LPCTSTR)strCompanyName, 
			(LPCTSTR)strAppName, 
			(LPCTSTR)m_strExtension, 
			szApplication
		);

		CRegKey keyExtension;
		if(ERROR_SUCCESS == keyExtension.Open(HKEY_CURRENT_USER, strKeyExtension, KEY_READ))
		{
			DWORD dwValue;
			if(ERROR_SUCCESS == keyExtension.QueryDWORDValue("Default", dwValue))
			{
				bIsDefault = (dwValue == 1);
			}
			keyExtension.Close();
		}

		// Anzeigename der Anwendung ermitteln und in Liste eintragen

		CString strKeyApplication;
		strKeyApplication.Format
		(
			"Software\\%s\\%s\\Applications\\%s", 
			(LPCTSTR)strCompanyName, 
			(LPCTSTR)strAppName, 
			szApplication
		);

		CRegKey keyApplication;
		if(ERROR_SUCCESS == keyApplication.Open(HKEY_CURRENT_USER, strKeyApplication, KEY_READ))
		{
			char szValue[MAX_PATH];
			DWORD dwCount = sizeof(szValue);

			if(ERROR_SUCCESS == keyApplication.QueryStringValue("DisplayName", szValue, &dwCount))
			{
				int nItem = m_lstApps.InsertItem(dwIndex, szValue);

				// Item der "Standard"-Anwendung vorauswhlen
				if(bIsDefault)
				{
					m_lstApps.SetItemState(nItem, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
				}

				CItemData *pItemData = new CItemData(szApplication, bIsDefault);
				m_lstApps.SetItemData(nItem, (DWORD)pItemData);

				keyApplication.Close();
			}
		}

		dwIndex++;
		dwCount = sizeof(szApplication);
	}

	keyExtension.Close();

	SetIcons();
	SortItems();
}

void COpenMenuDlg::SetIcons()
{
	CString strCompanyName(AfxGetApp()->m_pszRegistryKey);
	CString strAppName(AfxGetApp()->m_pszAppName);

	// Image-Liste fr die Icons
	CImageList* pImageList = new CImageList;
	pImageList->Create(32, 32, ILC_COLOR32 | ILC_MASK, 0, 0);

	// Image-Liste fllen
	for(int nItem = 0; nItem < m_lstApps.GetItemCount(); nItem++)
	{
		// Pfad der Anwendung ermitteln
		CItemData *pItemData = (CItemData*)m_lstApps.GetItemData(nItem);
		CString strApplication = pItemData->m_strApplication;

		CString strKeyApplication;
		strKeyApplication.Format
		(
			"Software\\%s\\%s\\Applications\\%s", 
			(LPCTSTR)strCompanyName, 
			(LPCTSTR)strAppName, 
			(LPCTSTR)strApplication
		);

		HICON hIcon = NULL;
		CRegKey keyApplication;
		if(ERROR_SUCCESS == keyApplication.Open(HKEY_CURRENT_USER, strKeyApplication, KEY_READ))
		{
			char szValue[MAX_PATH];
			DWORD dwCount = sizeof(szValue);

			if(ERROR_SUCCESS == keyApplication.QueryStringValue("Path", szValue, &dwCount))
			{
				hIcon = GetFileIcon(szValue);
			}

			keyApplication.Close();
		}

		if(hIcon == NULL)
		{
			hIcon = AfxGetApp()->LoadIcon(IDI_ICON_WINDOW);
		}

		pImageList->Add(hIcon);
		DestroyIcon(hIcon);
	}

	// Image-Liste setzen
	m_lstApps.SetImageList(pImageList, LVSIL_NORMAL);	

	// Icons setzen
	for(int nItem = 0; nItem < m_lstApps.GetItemCount(); nItem++)
	{
		m_lstApps.SetItem(nItem, 0, LVIF_IMAGE, NULL, nItem, 0, 0, NULL);
	}

}

void COpenMenuDlg::SortItems()
{
	m_lstApps.Arrange(LVA_DEFAULT);
	m_lstApps.SortItems(CompareItems, (LPARAM)&m_lstApps);
}

int CALLBACK COpenMenuDlg::CompareItems(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
   // lParamSort contains a pointer to the list view control.
   // The lParam of an item is just its index.
   CListCtrl* plstApps = (CListCtrl*)lParamSort;
   CString strItem1 = plstApps->GetItemText(lParam1, 0);
   CString strItem2 = plstApps->GetItemText(lParam2, 0);

   return strcmp(strItem2, strItem1);
}

bool COpenMenuDlg::AddApplication(CString strPath, CString strName, CString strTitle)
{
	CString strCompanyName(AfxGetApp()->m_pszRegistryKey);
	CString strAppName(AfxGetApp()->m_pszAppName);

	  ///////////////
	 // Anwendung //
	///////////////

	CString strKeyApplication;
	strKeyApplication.Format
	(
		"Software\\%s\\%s\\Applications\\%s", 
		(LPCTSTR)strCompanyName, 
		(LPCTSTR)strAppName, 
		(LPCTSTR)strName
	);

	CRegKey keyApplication;
	if(ERROR_SUCCESS == keyApplication.Open(HKEY_CURRENT_USER, strKeyApplication, KEY_READ))
	{
		// Anwendung existiert bereits
		keyApplication.Close();
	}
	else if(ERROR_SUCCESS == keyApplication.Create(HKEY_CURRENT_USER, strKeyApplication))
	{
		if
		(
			ERROR_SUCCESS == keyApplication.SetStringValue("Path", strPath) &&
			ERROR_SUCCESS == keyApplication.SetStringValue("DisplayName", strTitle)
		)
		{
			keyApplication.Close();
		}
		else
		{
			AfxMessageBox(CString(MAKEINTRESOURCE(IDS_MSG_ERROR_WRITING_REGKEY)) + ":\n" + strKeyApplication);
			keyApplication.Close();
			return false;
		}
	}
	else
	{
		AfxMessageBox(CString(MAKEINTRESOURCE(IDS_MSG_ERROR_CREATING_REGKEY)) + ":\n" + strKeyApplication);
		return false;
	}

	keyApplication.Close();

	  /////////////////////////////////////////////
	 // Zuordnung Anwendung zu Dateierweiterung //
	/////////////////////////////////////////////

	CString strKeyExtension;
	strKeyExtension.Format
	(
		"Software\\%s\\%s\\Extensions\\%s\\%s", 
		(LPCTSTR)strCompanyName, 
		(LPCTSTR)strAppName, 
		(LPCTSTR)m_strExtension, 
		(LPCTSTR)strName
	);

	CRegKey keyExtension;
	if(ERROR_SUCCESS == keyExtension.Open(HKEY_CURRENT_USER, strKeyExtension, KEY_READ))
	{
		AfxMessageBox(CString(MAKEINTRESOURCE(IDS_MSG_ERROR_ASSIGNMENT_EXISTS)));
		keyExtension.Close();
		return false;
	}

	if(ERROR_SUCCESS == keyExtension.Create(HKEY_CURRENT_USER, strKeyExtension))
	{
		if(ERROR_SUCCESS == keyExtension.SetDWORDValue("Default", (DWORD)0))
		{
			keyApplication.Close();
		}
		else
		{
			AfxMessageBox(CString(MAKEINTRESOURCE(IDS_MSG_ERROR_WRITING_REGKEY)) + ":\n" + strKeyExtension);
			keyApplication.Close();
			return false;
		}
	}
	else
	{
		AfxMessageBox(CString(MAKEINTRESOURCE(IDS_MSG_ERROR_CREATING_REGKEY)) + ":\n" + strKeyExtension);
		return false;
	}

	return true;
}

bool COpenMenuDlg::DeleteAssignment()
{
	CString strCompanyName(AfxGetApp()->m_pszRegistryKey);
	CString strAppName(AfxGetApp()->m_pszAppName);

	// Anwendung aus Liste ermitteln

	if(m_lstApps.GetSelectedCount() != 1)
		return false;

	int nItem = -1;
	POSITION pos = m_lstApps.GetFirstSelectedItemPosition();
	if(pos)
	{
		nItem = m_lstApps.GetNextSelectedItem(pos);
	}

	if(nItem == -1)
		return false;

	CItemData *pItemData = (CItemData*)m_lstApps.GetItemData(nItem);
	CString strApplication = pItemData->m_strApplication;

	// Zuordnung Anwendung zu Dateityp lschen

	CString strKeyExtension;
	strKeyExtension.Format
	(
		"Software\\%s\\%s\\Extensions\\%s", 
		(LPCTSTR)strCompanyName, 
		(LPCTSTR)strAppName, 
		(LPCTSTR)m_strExtension
	);

	CRegKey keyExtension;
	if(ERROR_SUCCESS != keyExtension.Open(HKEY_CURRENT_USER, strKeyExtension, KEY_WRITE))
	{
		AfxMessageBox(CString(MAKEINTRESOURCE(IDS_MSG_ERROR_OPENING_REGKEY)) + ":\n" + strKeyExtension);
		return false;
	}

	if(ERROR_SUCCESS != keyExtension.RecurseDeleteKey(strApplication))
	{
		AfxMessageBox(CString(MAKEINTRESOURCE(IDS_MSG_ERROR_DELETING_REGKEY)) + ":\n" + strKeyExtension);
		keyExtension.Close();
		return false;
	}

	keyExtension.Close();

	// Dateityp entfernen, falls keine weiteren Anwendungszuordnungen mehr existieren

	DWORD dwIndex = 0;
	char szApplication[MAX_PATH];
	DWORD dwCount = sizeof(szApplication);

	if(ERROR_SUCCESS == keyExtension.Open(HKEY_CURRENT_USER, strKeyExtension, KEY_READ))
	{
		while(ERROR_SUCCESS == RegEnumKeyEx(keyExtension.m_hKey, dwIndex, szApplication, &dwCount, NULL, NULL, NULL, NULL))
		{
			dwIndex++;
			dwCount = sizeof(szApplication);
		}

		keyExtension.Close();
	}

	CString strKeyExtensions;
	strKeyExtensions.Format
	(
		"Software\\%s\\%s\\Extensions", 
		(LPCTSTR)strCompanyName, 
		(LPCTSTR)strAppName
	);

	if(dwIndex == 0)
	{
		CRegKey keyExtensions;
		if(ERROR_SUCCESS == keyExtensions.Open(HKEY_CURRENT_USER, strKeyExtensions, KEY_WRITE))
		{
			keyExtensions.RecurseDeleteKey(m_strExtension);
			keyExtensions.Close();
		}
	}

	// Weitere Zuordnungen dieser Anwendung zu einem Dateityp suchen

	int nCountAssignments = 0;

	CRegKey keyExtensions;
	if(ERROR_SUCCESS != keyExtensions.Open(HKEY_CURRENT_USER, strKeyExtensions, KEY_READ))
	{
		return true;
	}

	dwIndex = 0;
	char szExtension[MAX_PATH];
	dwCount = sizeof(szExtension);

	while(ERROR_SUCCESS  == RegEnumKeyEx(keyExtensions.m_hKey, dwIndex, szExtension, &dwCount, NULL, NULL, NULL, NULL))
	{
		CString strKeyExtension;
		strKeyExtension.Format
		(
			"Software\\%s\\%s\\Extensions\\%s\\%s", 
			(LPCTSTR)strCompanyName, 
			(LPCTSTR)strAppName, 
			szExtension, 
			(LPCTSTR)strApplication
		);

		CRegKey keyExtension;
		if(ERROR_SUCCESS == keyExtension.Open(HKEY_CURRENT_USER, strKeyExtension, KEY_READ))
		{
			nCountAssignments++;
			keyExtension.Close();
		}

		dwIndex++;
		dwCount = sizeof(szExtension);
	}
	
	keyExtensions.Close();

	// Anwendung entfernen, falls keine Zuordnungen zu einem Dateityp existieren

	if(nCountAssignments == 0)
	{
		CString strKeyApplications;
		strKeyApplications.Format
		(
			"Software\\%s\\%s\\Applications", 
			(LPCTSTR)strCompanyName, 
			(LPCTSTR)strAppName
		);

		CRegKey keyApplications;
		if(ERROR_SUCCESS == keyApplications.Open(HKEY_CURRENT_USER, strKeyApplications, KEY_WRITE))
		{
			keyApplications.RecurseDeleteKey(strApplication);
			keyApplications.Close();
		}
	}

	return true;
}

CString COpenMenuDlg::GetFileExtension(CString strPath)
{
	CString strExtension;

	int nPosLastDot = strPath.ReverseFind('.');
	int nPosLastBackslash = strPath.ReverseFind('\\');

	if(nPosLastDot == -1)
		return strExtension;

	if(nPosLastDot < nPosLastBackslash)
		return strExtension;

	strExtension = strPath.Mid(nPosLastDot + 1);

	return strExtension;
}

CString COpenMenuDlg::Quote(CString strString)
{
	CString strResult;
	strResult.Format("\"%s\"", (LPCTSTR)strString);
	return strResult;
}

HICON COpenMenuDlg::GetFileIcon(CString strPath)
{
	HICON hIcon;

// Icon aus Anwendung extrahieren - funktioniert nur bei EXE-Dateien:
//	HICON phiconLarge[1];
//	CString strAppExtension = GetFileExtension(strPath);
//	if(ExtractIconEx(strPath, 0, phiconLarge, NULL, 1) == 1)
//	{
//		hIcon = phiconLarge[0];
//	}
//	else if(strAppExtension == "bat" || strAppExtension == "cmd")
//	{
//		hIcon = AfxGetApp()->LoadIcon(IDI_ICON_BATCH);
//	}
//	else
//	{
//		hIcon = AfxGetApp()->LoadIcon(IDI_ICON_WINDOW);
//	}
// Daher besser so:

	SHFILEINFOA sfi = { 0 };
	HRESULT hr = SHGetFileInfo(strPath, 0, &sfi, sizeof(sfi), SHGFI_ICON | SHGFI_LARGEICON);
	if(SUCCEEDED(hr))
	{
		hIcon = sfi.hIcon;
	}
	else
	{
		hIcon = AfxGetApp()->LoadIcon(IDI_ICON_WINDOW);
	}

	return hIcon;
}
 
void COpenMenuDlg::LoadSettings()
{
	CString strCompanyName(AfxGetApp()->m_pszRegistryKey);
	CString strAppName(AfxGetApp()->m_pszAppName);

	CString strKeyExtension;
	strKeyExtension.Format
	(
		"Software\\%s\\%s\\Extensions\\%s",
		(LPCTSTR)strCompanyName,
		(LPCTSTR)strAppName,
		(LPCTSTR)m_strExtension
	);

	CRegKey keyExtension;
	if (ERROR_SUCCESS == keyExtension.Open(HKEY_CURRENT_USER, strKeyExtension, KEY_READ))
	{
		int nWindowLeft, nWindowTop, nWindowWidth, nWindowHeight;
		if (ERROR_SUCCESS == keyExtension.QueryDWORDValue("WindowLeft", (DWORD&)nWindowLeft)
		&& ERROR_SUCCESS == keyExtension.QueryDWORDValue("WindowTop", (DWORD&)nWindowTop)
		&& ERROR_SUCCESS == keyExtension.QueryDWORDValue("WindowWidth", (DWORD&)nWindowWidth)
		&& ERROR_SUCCESS == keyExtension.QueryDWORDValue("WindowHeight", (DWORD&)nWindowHeight))
		{
			SetWindowPos(NULL, nWindowLeft, nWindowTop, nWindowWidth, nWindowHeight, SWP_NOZORDER);
		}
		keyExtension.Close();
	}
}

void COpenMenuDlg::SaveSettings()
{
	CRect rcWindowRect;
	GetWindowRect(rcWindowRect);

	CString strCompanyName(AfxGetApp()->m_pszRegistryKey);
	CString strAppName(AfxGetApp()->m_pszAppName);

	CString strKeyExtension;
	strKeyExtension.Format
	(
		"Software\\%s\\%s\\Extensions\\%s",
		(LPCTSTR)strCompanyName,
		(LPCTSTR)strAppName,
		(LPCTSTR)m_strExtension
	);

	CRegKey keyExtension;
	if (ERROR_SUCCESS == keyExtension.Open(HKEY_CURRENT_USER, strKeyExtension, KEY_WRITE))
	{
		keyExtension.SetDWORDValue("WindowLeft", rcWindowRect.left);
		keyExtension.SetDWORDValue("WindowTop", rcWindowRect.top);
		keyExtension.SetDWORDValue("WindowWidth", rcWindowRect.Width());
		keyExtension.SetDWORDValue("WindowHeight", rcWindowRect.Height());
		keyExtension.Close();
	}
}

