#pragma once

/////////////////////////////////////////////////////////////////////////////
// COpenMenuDlg Dialogfeld

class COpenMenuDlg : public CDialog
{
	friend class CEditDlg;

// Konstruktion
public:
	COpenMenuDlg(CString strPath, CWnd* pParent = NULL);	// Standard-Konstruktor

// Dialogfelddaten
	//{{AFX_DATA(COpenMenuDlg)
	enum { IDD = IDD_OPENMENU_DIALOG };
	CListCtrl	m_lstApps;
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(COpenMenuDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	HICON m_hIcon;

	// Generierte Message-Map-Funktionen
	//{{AFX_MSG(COpenMenuDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnOK();
	afx_msg void OnCancel();
	afx_msg void OnClose();
	afx_msg void OnClickListApps(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnMenuOpen();
	afx_msg void OnMenuDefault();
	afx_msg void OnMenuAdd();
	afx_msg void OnMenuEdit();
	afx_msg void OnMenuDelete();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	bool BrowseAppFile(CString& strPath, CString& strName, CString& strTitle);
	void LoadAppList();
	void SetIcons();
	void SortItems();
	static int CALLBACK CompareItems(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
	bool AddApplication(CString strPath, CString strName, CString strTitle);
	bool DeleteAssignment();
	CString GetFileExtension(CString strPath);
	CString Quote(CString strString);
	HICON GetFileIcon(CString strPath);
	void LoadSettings();
	void SaveSettings();

private:
	CString m_strPath;
	CString m_strExtension;

	class CItemData
	{
	public:
		CItemData(CString strApplication, bool bIsDefault)
		{
			m_strApplication = strApplication;
			m_bIsDefault = bIsDefault;
		};
		~CItemData() {};
	public:
		CString m_strApplication;
		CString m_strParameters;
		bool m_bIsDefault;
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.
